-- You can now play as <insert maril here> Maril!
-- Maril!!! <3
-- The bee-fox creature, in doodle form, playable by beating Specki Robo Blast II.

-- Piano Freeslots are separated for easy use.

freeslot(
	"sfx_pinc3",
	"sfx_pinc4",
	"sfx_pinc5",
	"sfx_pinc6",
	"sfx_pincs3",
	"sfx_pincs4",
	"sfx_pincs5",
	"sfx_pind3",
	"sfx_pind4",
	"sfx_pind5",
	"sfx_pinds3",
	"sfx_pinds4",
	"sfx_pinds5",
	"sfx_pine3",
	"sfx_pine4",
	"sfx_pine5",
	"sfx_pinf3",
	"sfx_pinf4",
	"sfx_pinf5",
	"sfx_pinfs3",
	"sfx_pinfs4",
	"sfx_pinfs5",
	"sfx_ping3",
	"sfx_ping4",
	"sfx_ping5",
	"sfx_pings3",
	"sfx_pings4",
	"sfx_pings5",
	"sfx_pina3",
	"sfx_pina4",
	"sfx_pina5",
	"sfx_pinas3",
	"sfx_pinas4",
	"sfx_pinas5",
	"sfx_pinb3",
	"sfx_pinb4",
	"sfx_pinb5",
	"sfx_spspin",
	"S_PLAY_MARIL_SPIN", -- galaxy spin
	"S_PLAY_MARIL_OUTTAHERE",
	"S_PLAY_MARIL_SWIM_IDLE",
	"S_PLAY_MARIL_SWIM",
	"S_PLAY_MARIL_SWIM_SPIN"
)

states[S_PLAY_MARIL_SPIN] = {
	sprite = SPR_PLAY, -- we're using a sprite2
	frame = SPR2_ROLL|FF_ANIMATE|A, -- would prefer if it started on A but idk how srb2 works,
	tics = 16, -- 16 tics to work with
	var1 = 7, -- 8 frames
	var2 = 2, -- 2 tics per frame
	nextstate = S_PLAY_FALL -- we're falling!!
}

states[S_PLAY_MARIL_OUTTAHERE] = {
	sprite = SPR_PLAY, -- we're using a sprite2
	frame = SPR2_BNCE|A,
	tics = -1 -- don't exist this state
}

states[S_PLAY_MARIL_SWIM_IDLE] = {
	sprite = SPR_PLAY,
	frame = SPR2_SWIM|A,
	tics = -1,
	nextstate = S_NULL
}

states[S_PLAY_MARIL_SWIM] = {
	sprite = SPR_PLAY,
	frame = SPR2_SWIM|FF_ANIMATE,
	tics = 12,
	var1 = 2,
	var2 = 4,
	nextstate = S_PLAY_MARIL_SWIM_IDLE
}

states[S_PLAY_MARIL_SWIM_SPIN] = {
	sprite = SPR_PLAY,
	frame = SPR2_MLEL|FF_ANIMATE,
	tics = 12,
	var1 = 3,
	var2 = 4,
	nextstate = S_PLAY_MARIL_SWIM_IDLE
}

local keypress = false
local shift = false
local ctrl = false
local note = ''

local piano_keytable = {
	['s'] = 'c',
	['e'] = 'cs',
	['d'] = 'd',
	['r'] = 'ds',
	['f'] = 'e',
	['g'] = 'f',
	['y'] = 'fs',
	['h'] = 'g',
	['u'] = 'gs',
	['j'] = 'a',
	['i'] = 'as',
	['k'] = 'b'
}

COM_AddCommand("maril_pianosync", function(p, arg, arg2, arg3, arg4)
	if not (p.mo and p.mo.valid) then return end
	if not p.mo.health then return end
	if p.mo.skin ~= "maril" then return end
	
	if p.maril_piano then
		p.mo.sprite2 = SPR2_MLEE
	
		if p.mo.frame ~= A and arg ~= "true" then
			p.mo.frame = A
		elseif p.mo.frame == A and arg == "true" then			
			if arg2 ~= "nil" then
				if arg4 == "true" then
					p.mo.frame = C
					S_StartSoundAtVolume(p.mo, _G["sfx_pin" .. arg2 .. tostring(5)], 1000)
				elseif arg3 == "true" then
						p.mo.frame = B
					S_StartSoundAtVolume(p.mo, _G["sfx_pin" .. arg2 .. tostring(4)], 1000)
				else
					p.mo.frame = D
					S_StartSoundAtVolume(p.mo, _G["sfx_pin" .. arg2 .. tostring(3)], 1000)
				end
			end
		end
	end
end)

addHook("KeyDown", function(key)
	keypress = true
	note = piano_keytable[key.name]
	
	if key.name == "lshift" or key.name == "rshift" then
		shift = true
	end
	
	if key.name == "lctrl" or key.name == "rctrl" then
		ctrl = true
	end
	
	COM_BufInsertText(consoleplayer, "maril_pianosync " .. tostring(keypress) .. " " .. tostring(note) .. " " .. tostring(shift) .. " " .. tostring(ctrl))
end)

addHook("KeyUp", function(key)
	keypress = false
	
	if key.name == "lshift" or key.name == "rshift" then
		shift = false
	end
	
	if key.name == "lctrl" or key.name == "rctrl" then
		ctrl = false
	end
	
	note = "nil"
	
	COM_BufInsertText(consoleplayer, "maril_pianosync " .. tostring(keypress) .. " " .. note .. " " .. tostring(shift) .. " " .. tostring(ctrl))
end)